// ==UserScript==
// @name         半次元图片下载器_bcy.net downloader
// @namespace    http://www.saber.xn--6qq986b3xl/?p=3001
// @version      0.1
// @description  下载半次元（bcy.net）网站里的图片
// @author       雪见仙尊
// @match        http://bcy.net/coser/detail/*
// @grant        none
// @run-at		document-end
// ==/UserScript==

/*
 *@作者：雪见仙尊
 *@博客：http://www.saber.xn--6qq986b3xl/
 *@转载重用请保留此信息
 *@QQ群：562729095
 */

var downloadTip = document.createElement("div");
downloadTip.id = "downloadTip";
document.body.appendChild(downloadTip);
downloadTip = document.querySelector("#downloadTip");
downloadTip.style.cssText = "position: fixed;right: 0;top: 100px;padding: 3px 10px;background:#FF6FA2;color:#fff;border-radius:2px;text-align: center;line-height: 24px;font-size: 16px;cursor: pointer;";
downloadTip.innerHTML = "下载此页面图片";
downloadTip.addEventListener("click", startDownload, false);

var phpPath = "http://127.0.0.1/bcy_download.php";
var artImgElement = document.querySelectorAll(".content-img-wrap img");
var artName = document.querySelector(".js-post-title").innerHTML.replace("\n", "");
var artNameReg = new RegExp(/'|#|&|\\|\/|:|\?|"|>|<|\*|\|/g); //去掉以下字符串 ' # \ / : ? " < > * | 其中'会导致php创建文件时路径异常而失败，#则是不能用在url里，否则从#开始往后的字符都不会被当做是参数。&也去掉。剩下几个是windows中不允许做文件名的字符
artName = artName.replace(artNameReg, "");
if (artName[artName.length - 1] == " ") {
	artName = artName.substr(0, artName.length - 1);
}
var coserName = document.querySelector(".blue1").innerHTML;
var imgUrls = [];
var fileNames = [];
for (var i = 0; i < artImgElement.length; i++) {
	imgUrls[i] = artImgElement[i].src.replace("/w650", "");
	fileNames[i] = i + 1;
}
var suffix = imgUrls[0].split(".");
suffix = suffix[suffix.length - 1];

var xhr = new XMLHttpRequest();
xhr.onreadystatechange = function() {
	if (xhr.readyState === 4) {
		if (xhr.status === 200) {
			if (imgUrls.length > 0) {
				download();
			} else {
				downloadTip.innerHTML = "下载完成！";
				alert("下载完成！");
			}
		} else {
			// alert("发生了异常，状态码为"+xhr.status+","+xhr.statusText);
		}
	}
}

function startDownload() {
	download();
	downloadTip.removeEventListener("click", startDownload, false); //开始下载后解绑提示区域的点击事件
}

function download() {
	downloadTip.innerHTML = "正在下载 " + fileNames[0] + "/" + artImgElement.length;
	var url = phpPath + "?url=" + imgUrls[0] + encodeURI("&coserName=" + coserName + "&artName=" + artName) + "&fileNames=" + fileNames[0].toString() + "." + suffix;
	imgUrls.shift();
	fileNames.shift();
	xhr.open("get", url, true);
	xhr.send(null);
}